osl::effect_util::Neighboring8Effect::Table Class Reference

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros
Classes | Public Member Functions | Private Member Functions | Private Attributes | List of all members
osl::effect_util::Neighboring8Effect::Table Class Reference
Collaboration diagram for osl::effect_util::Neighboring8Effect::Table:
[legend]

## Classes
struct | Entry

## Public Member Functions
| Table ()
bool | hasEffect (const NumEffectState &state, PtypeO ptypeo, Square from, Square target) const

## Private Member Functions
void | init (Player)
template<int maxCount>
bool | hasAtMaxPieceBetween (const NumEffectState &state, Square from, Square target) const

## Private Attributes
CArray2d< Entry, PTYPEO_SIZE, Offset32::SIZE > | table

## Detailed Description

Definition at line 19 of file neighboring8Effect.h.

## Constructor & Destructor Documentation

osl::effect_util::Neighboring8Effect::Table::Table | ( | ) |  |

Definition at line 6 of file neighboring8Effect.cc.

References osl::BLACK, and osl::WHITE.

## Member Function Documentation

template<int maxCount>

bool osl::effect_util::Neighboring8Effect::Table::hasAtMaxPieceBetween | ( | const NumEffectState & | state,
|  | Square | from,
|  | Square | target
| ) |  | const
| inlineprivate

Definition at line 33 of file neighboring8Effect.h.

References osl::Board_Table, count, osl::BoardTable::getShortOffset(), osl::Square::isOnBoard(), and target.

bool osl::effect_util::Neighboring8Effect::Table::hasEffect | ( | const NumEffectState & | state,
|  | PtypeO | ptypeo,
|  | Square | from,
|  | Square | target
| ) |  | const
| inline

Definition at line 54 of file neighboring8Effect.h.

References osl::getPtype(), osl::effect_util::Neighboring8Effect::Table::Entry::has_unblockable_effect, osl::PtypeTable::hasLongMove(), osl::Offset32Base< Width, Width2 >::index(), osl::effect_util::Neighboring8Effect::Table::Entry::nearest, osl::Ptype_Table, osl::ptypeOIndex(), table, and osl::Offset::zero().

Referenced by osl::effect_util::Neighboring8Effect::hasEffect().

void osl::effect_util::Neighboring8Effect::Table::init | ( | Player | player) |  |
| private

Definition at line 13 of file neighboring8Effect.cc.

References osl::Board_Table, osl::DIRECTION_MAX, osl::DIRECTION_MIN, osl::Offset::dx(), osl::Offset::dy(), osl::PtypeTable::getMoveMask(), osl::BoardTable::getOffset(), osl::Offset32Base< Width, Width2 >::index(), osl::isLong(), osl::isPiece(), osl::effect_util::Neighboring8Effect::Table::Entry::nearest, osl::newPtypeO(), osl::PTYPE_MAX, osl::PTYPE_PIECE_MIN, osl::Ptype_Table, osl::ptypeOIndex(), and osl::Offset::zero().

## Member Data Documentation

CArray2d<Entry,PTYPEO_SIZE,Offset32::SIZE> osl::effect_util::Neighboring8Effect::Table::table
| private

Definition at line 29 of file neighboring8Effect.h.

Referenced by hasEffect().

The documentation for this class was generated from the following files:

- neighboring8Effect.h
- neighboring8Effect.cc